package DE.fub.inf.JVM.ClassGen;

/** 
 * IFEQ - Branch if int comparison with zero succeeds
 *
 * Stack: ...,  value -> ...
 *
 * @version $Id: IFEQ.java,v 1.4 1998/10/22 14:06:04 dahm Exp $
 * @author  <A HREF="http://www.inf.fu-berlin.de/~dahm">M. Dahm</A>
 */
public class IFEQ extends IfInstruction {
  /**
   * Empty constructor needed for the Class.newInstance() statement in
   * Instruction.readInstruction(). Not to be used otherwise.
   */
  IFEQ() {}

  public IFEQ(InstructionHandle target) {
    super(IFEQ, target);
  }

  /**
   * @return negation of instruction, e.g. IFEQ.negate() == IFNE
   */
  public IfInstruction negate() {
    return new IFNE(target);
  }
}

