package DE.fub.inf.JVM.ClassGen;

/** 
 * LCONST - Push 0 or 1, other values cause an exception
 *
 * Stack: ... -> ..., <i>
 *
 * @version $Id: LCONST.java,v 1.3 1998/10/16 09:54:07 dahm Exp $
 * @author  <A HREF="http://www.inf.fu-berlin.de/~dahm">M. Dahm</A>
 */
public class LCONST extends Instruction implements ConstantPushInstruction {
  private long value;

  /**
   * Empty constructor needed for the Class.newInstance() statement in
   * Instruction.readInstruction(). Not to be used otherwise.
   */
  LCONST() {}

  public LCONST(long f) {
    super(LCONST_0, (short)1);

    if(f == 0)
      tag = LCONST_0;
    else if(f == 1)
      tag = LCONST_1;
    else
      throw new ClassGenException("LCONST can be used only for 0 and 1: " + f);

    value = f;
  }

  public Number getValue() { return new Long(value); }
}
